<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
      <el-form-item label="TTS平台" prop="platform">
        <el-select v-model="formData.platform" placeholder="请选择平台" clearable >
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.AI_PLATFORM)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="发音人名字" prop="name">
        <el-input v-model="formData.name" placeholder="请输入发音人名字" />
      </el-form-item>
      <el-form-item label="发音人标识" prop="model">
        <el-input v-model="formData.model" placeholder="请输入发音人标识" />
      </el-form-item>
      <el-form-item label="发音人类型" prop="type">
        <el-select v-model="formData.type" placeholder="请选择发音人类型">
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.AI_TTS_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="语速" prop="speechRate">
        <el-slider v-model="formData.speechRate" show-input size="large" :min="-500" :max="500" :step="1" />
      </el-form-item>
      <el-form-item label="语调" prop="volume">
        <el-slider v-model="formData.volume" show-input size="large" :min="-500" :max="500" :step="1" />
      </el-form-item>
      <el-form-item label="音量" prop="pitchRate">
        <el-slider v-model="formData.pitchRate" show-input size="large" :min="-100" :max="100" :step="1" />
      </el-form-item>
      <el-form-item label="情感" prop="emotion">
        <el-input v-model="formData.emotion" placeholder="请输入情感" />
      </el-form-item>
      <el-form-item label="语音指令" prop="command">
        <el-input v-model="formData.command" placeholder="请输入语音指令" />
      </el-form-item>
      <el-form-item label="排序" prop="sort">
        <el-input-number v-model="formData.sort"  :step="1" :min="1" />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select
          v-model="formData.status"
          placeholder="请选择状态"
          clearable
        >
          <el-option
            v-for="dict in getIntDictOptions(DICT_TYPE.COMMON_STATUS)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE, getStrDictOptions } from '@/utils/dict'
import { TtsApi, TtsVO } from '@/api/ai/tts'

/** AI TTS文转音 表单 */
defineOptions({ name: 'TtsForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  model: undefined,
  platform: undefined,
  type: undefined,
  sort: undefined,
  status: undefined,
  speechRate: undefined,
  volume: undefined,
  pitchRate: undefined,
  emotion: undefined,
  command: undefined
})
const formRules = reactive({
  name: [{ required: true, message: '发音人名字不能为空', trigger: 'blur' }],
  model: [{ required: true, message: '发音人标识不能为空', trigger: 'blur' }],
  platform: [{ required: true, message: 'TTS平台不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await TtsApi.getTts(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as TtsVO
    if (formType.value === 'create') {
      await TtsApi.createTts(data)
      message.success(t('common.createSuccess'))
    } else {
      await TtsApi.updateTts(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    model: undefined,
    platform: undefined,
    type: undefined,
    sort: undefined,
    status: undefined,
    speechRate: undefined,
    volume: undefined,
    pitchRate: undefined,
    emotion: undefined,
    command: undefined
  }
  formRef.value?.resetFields()
}
</script>
